#include <BleKeyboard.h>
#include <M5StickC.h>
/* #include <M5Stack.h> */

BleKeyboard bleKeyboard("Clicker Bluetooth","Programmez",100);

void setup() {
  M5.begin();
  Serial.begin(115200);
  Serial.println("Starting BLE work!");
  bleKeyboard.begin(); 
  M5.Axp.ScreenBreath(10); 
/*  M5.Lcd.setBrightness(100); */
}

boolean redrawA = true;
boolean redrawB = true;
const int triangles[2][6] = {{20,70,60,70,40,30},{20,80,60,80,40,120}};

void draw_triangle(boolean pressed, int t,int color, boolean *redraw)
{
  if (pressed) 
  {    
    M5.Lcd.fillTriangle(triangles[t][0],triangles[t][1],triangles[t][2],
                        triangles[t][3],triangles[t][4],triangles[t][5],color);
  }
  else
  {
    if (*redraw)
    {
      M5.Lcd.fillTriangle(triangles[t][0],triangles[t][1],triangles[t][2],
                          triangles[t][3],triangles[t][4],triangles[t][5],BLACK);
      M5.Lcd.drawTriangle(triangles[t][0],triangles[t][1],triangles[t][2],
                          triangles[t][3],triangles[t][4],triangles[t][5],color);
      *redraw=false;
    }
  }
}

void loop() {
  draw_triangle(M5.BtnA.read(),0,GREEN,&redrawA);
  draw_triangle(M5.BtnB.read(),1,RED  ,&redrawB);
  
  if(bleKeyboard.isConnected()) 
  {
    if (M5.BtnA.wasPressed())  
    {
      Serial.println("Sending KEY_DOWN_ARROW");
      bleKeyboard.write(KEY_DOWN_ARROW);
      redrawA = true;
    }
    if (M5.BtnB.wasPressed())  
    {            
      Serial.println("Sending KEY_UP_ARROW");
      bleKeyboard.write(KEY_UP_ARROW);
      redrawB = true;
    }
  }
  delay(100);
}
